#include<bits/stdc++.h>
using namespace std;
int n,m,q,br2,a,b;
unsigned long long br,br1,z;
int main(){
    cin>>n>>m;
    long long x[n+5][m+5];
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cin>>x[i][j];
        }
    }
    cin>>q;
    for(int k=1;k<=q;k++){
        cin>>a>>b;
        z=x[a][b];
        x[a][b]=1e9;
    br1=1e9;
    br2=m+1;
    for(int h=1;h<=m;h++){
    br=0;
    br2--;
    for(int j=1;j<=br2;j++){
        br+=x[1][j];
    }
    for(int j=br2;j<=m;j++){
        br+=x[2][j];
    }
    br1=min(br1,br);
    }
    x[a][b]=z;
    cout<<br1<<endl;
    }
return 0;
}